<?php 
namespace Concrete\Package\DatabaseDumper;

use Concrete\Package\DatabaseDumper\Service\Provider as DBDumperServiceProvider;
use Concrete\Core\Database\EntityManager\Provider\ProviderInterface;
use Concrete\Core\Foundation\Service\ProviderList;
use Concrete\Core\Support\Facade\Application;
use Concrete\Core\Package\Package;
use SinglePage;

class Controller extends Package implements ProviderInterface
{
    protected $pkgHandle = 'database_dumper';
    protected $appVersionRequired = '8.1.0';
    protected $pkgVersion = '1.1.0';
    protected $pkgAutoloaderRegistries = [
        'src' => 'Concrete\Package\DatabaseDumper',
    ];

    public function getPackageName()
    {
        return t('Database Dumper');
    }

    public function getPackageDescription()
    {
        return t('Create and download database dump');
    }

    public function install()
    {
        $pkg = parent::install();
        $sp = SinglePage::add('/dashboard/system/environment/database_dumper', $pkg);
        $sp->update(['cName' => $pkg->getPackageName(), 'cDescription' => $pkg->getPackageDescription()]);
    }

    public function on_start()
    {
        $this->app(ProviderList::class)->registerProvider(DBDumperServiceProvider::class);
    }

    /**
     * @param string $make [optional]
     *
     * @return \Concrete\Core\Application\Application|mixed
     */
    protected function app($make = null)
    {
        if (!$this->app) {
            $this->app = Application::getFacadeApplication();
        }

        if (!is_null($make)) {
            return $this->app->make($make);
        }

        return $this->app;
    }

    /**
     * {@inheritDoc}
     */
    public function getDrivers()
    {
        return [];
    }
}
