<?php
namespace Concrete\Package\DatabaseDumper\Controller\SinglePage\Dashboard\System\Environment;

use Concrete\Core\Page\Controller\DashboardPageController;
use Concrete\Package\DatabaseDumper\ApplicationTrait;
use Concrete\Package\DatabaseDumper\Dumper;

class DatabaseDumper extends DashboardPageController
{
    use ApplicationTrait;

    public function view()
    {
        $this->set('outputs', ['file' => t('SQL File'), 'zip' => t('Zip'), 'gzip' => t('GZip')]);
    }

    public function dump()
    {
        if (!$this->token->validate('database_dump')) {
            $this->error->add(t('Invalid Form Token'));

            return;
        }
        /* @var \Concrete\Package\DatabaseDumper\Dumper $dumper */
        $dumper = $this->app(Dumper::class);
        $dumper->run(['output' => $this->request->post('output')]);
    }
}
