<?php
namespace Concrete\Package\DatabaseDumper\Database\Connection;

use Concrete\Package\DatabaseDumper\Utility\Str;

class PDO extends PDOBase
{
    public $extension = "PDO_MySQL";

    public function connect($server, $user, $pwd)
    {
        $this->dsn("mysql:charset=utf8;host=" . str_replace(":", ";unix_socket=", preg_replace('~:(\d)~', ';port=\1', $server)), $user, $pwd);

        return true;
    }

    public function set_charset($charset)
    {
        $this->query("SET NAMES $charset");
    }

    public function select_db($dbname)
    {
        return $this->query("USE " . Str::idf_escape($dbname));
    }

    /**
     * @param string $sql
     * @param bool $_g
     *
     * @return bool|\PDOStatement
     */
    public function query($sql, $_g = false)
    {
        $this->setAttribute(self::MYSQL_ATTR_USE_BUFFERED_QUERY, !$_g);

        return parent::query($sql, $_g);
    }
}
