<?php
namespace Concrete\Package\DatabaseDumper\Database\Connection\PDO;

class LightPDOStatement extends \PDOStatement
{
    public $_offset = 0;
    public $num_rows;

    public function fetch_assoc()
    {
        return $this->fetch(\PDO::FETCH_ASSOC);
    }

    public function fetch_row()
    {
        return $this->fetch(\PDO::FETCH_NUM);
    }

    public function fetch_field()
    {
        $cm = (object) $this->getColumnMeta($this->_offset++);
        $cm->orgtable = $cm->table;
        $cm->orgname = $cm->name;
        $cm->charsetnr = (in_array("blob", (array) $cm->flags) ? 63 : 0);

        return $cm;
    }
}
