<?php
namespace Concrete\Package\DatabaseDumper\Utility;

class DB
{
    public static function table($tableName)
    {
        return Str::idf_escape($tableName);
    }

    public static function is_view($table_status)
    {
        return null === $table_status["Engine"];
    }

    public static function unique_array($L, $v)
    {
        foreach ($v as $u) {
            if (preg_match("~PRIMARY|UNIQUE~", $u["type"])) {
                $K = [];
                foreach ($u["columns"]as $y) {
                    if (!isset($L[$y])) {
                        continue 2;
                    }
                    $K[$y] = $L[$y];
                }

                return $K;
            }
        }
    }

    /** Formulate SQL modification query with limit 1
     * @param string everything after UPDATE or DELETE
     * @param string
     *
     * @return string
     */
    public static function limit1($query, $where)
    {
        return static::limit($query, $where, 1);
    }

    /** Formulate SQL query with limit
     * @param string everything after SELECT
     * @param string including WHERE
     * @param int
     * @param int
     * @param string
     *
     * @return string
     */
    public static function limit($query, $where, $limit, $offset = 0, $separator = " ")
    {
        return " $query$where" . (null !== $limit ? $separator . "LIMIT $limit" . ($offset ? " OFFSET $offset" : "") : "");
    }

    /** Remove current user definer from SQL command
     * @param string
     *
     * @return string
     */
    public static function remove_definer($query, $loggedUser)
    {
        return preg_replace('~^([A-Z =]+) DEFINER=`' . preg_replace('~@(.*)~', '`@`(%|\\1)', $loggedUser) . '`~', '\\1', $query); //! proper escaping of user
    }
}
