<?php
namespace Concrete\Package\DatabaseDumper\Utility;

use Concrete\Core\Support\Facade\Application;

class Str
{
    public static function idf_escape($str)
    {
        return "`" . str_replace("`", "``", $str) . "`";
    }

    /** Unescape database identifier
     * @param string text inside ``
     *
     * @return string
     */
    public static function idf_unescape($str)
    {
        $id = substr($str, -1);

        return str_replace($id . $id, $id, substr($str, 1, -1));
    }

    public static function escape_string($str)
    {
        $app = Application::getFacadeApplication();

        return substr($app['xan/dumper/db']->quote($str), 1, -1);
    }

    /** Disable magic_quotes_gpc
     * @param array e.g. (&$_GET, &$_POST, &$_COOKIE)
     * @param bool whether to leave values as is
     */
    public static function remove_slashes($process, $filter = false)
    {
        if (get_magic_quotes_gpc()) {
            foreach ($process as $key => $val) {
                foreach ($val as $k => $v) {
                    unset($process[$key][$k]);
                    if (is_array($v)) {
                        $process[$key][stripslashes($k)] = $v;
                        $process[] = &$process[$key][stripslashes($k)];
                    } else {
                        $process[$key][stripslashes($k)] = ($filter ? $v : stripslashes($v));
                    }
                }
            }
        }
    }

    public static function bracket_escape($str, $_a = false)
    {
        $sg = [':' => ':1', ']' => ':2', '[' => ':3', '"' => ':4'];

        return strtr($str, ($_a ? array_flip($sg) : $sg));
    }

    public static function hschr($v)
    {
        return str_replace("\0", "&#0;", htmlspecialchars($v, ENT_QUOTES, 'utf-8'));
    }
}
